{ ENCORE ROUTER CONTROL V1.0 }
                           
OBJ
  Debug : "FullDuplexSerial" 
  Data  :  "Extended_FDSerial_128ByteBuffers"
  heart : "heartbeat"     'object that makes an LED blink for showing propeller-chip is alive and working
  
Var
  'ATTENTION !!!
  'to avoid datacrashing you have to use the value of the constant MaxStrLength
  'of the object Extended_FDSerial_128ByteBuffers !
  'For the bytearrays that are used for received strings. 
  'The value of this constant can be accessed by writing objectname#constantname 
  Byte  MyStr[Data#MaxStrLength]  


CON    
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  
PUB Start
  'Data.Start(27,26,2,9600)
  'Debug.Start(31,30,0,9600)
     
  Data.Start(31,30,0,9600)

  heart.Start(0,250) 'blinking on PIN 0 as Lifesignal of PropellerChip

  Data.str(string("Data.Start(31,30,0,9600)"))

  {
  'testing sending with a hardcoded string to see 
  'if characters are received properly by a terminalsoftware
  
  repeat
    Data.str(string("Hello",13))
    WaitCnt(ClkFreq + cnt)
  }

  'testing sending and receiving a string
  repeat 
    Data.rxstr(@mystr)
    Data.str(string("string received",13))
    Data.str(@mystr)
    Data.tx(13)
    Data.tx(13)

    
PUB Stop

  Data.Stop

PUB SendSource(dst, src) | cksm, dst_1, dst_2, dst_3, dst_4, src_1, src_2, src_3, src_4


  dst := dst - 1
  src := src - 1
  
  dst <<= 4 << 2

  dst_1 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_2 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_3 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_4 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))

  src <<= 4 << 2
  src_1 := (lookupz((src <-= 4) & $F : "0".."9", "A".."F")) 
  src_2 := (lookupz((src <-= 4) & $F : "0".."9", "A".."F")) 
  src_3 := (lookupz((src <-= 4) & $F : "0".."9", "A".."F")) 
  src_4 := (lookupz((src <-= 4) & $F : "0".."9", "A".."F")) 
  
  cksm := (-1*((301 + dst_1 + dst_2 + dst_3 + dst_4 + src_1 + src_2 + src_3 + src_4)//256))+256  
 
  Data.tx(01)
  Data.tx(78)
  Data.tx(48)
  Data.tx(84)
  Data.tx(73)
  Data.tx(09)
  Data.hex(dst,4)
  Data.tx(09)
  Data.hex(src,4)
  Data.hex(cksm,2)
  Data.tx(04)

  waitcnt((100_000 + cnt))
  
  Data.tx(06)
 

PUB GetSource(dst) : src | cksm, dst_1, dst_2, dst_3, dst_4, rx1, rx2, rx3, rx4, rx5, rx6, rx7, rx8, rx9, rx10, rx11, rx12, rx13, rx14, rx15, rx16, rx17, rx18, rx19, rx20, rx21, rx22

  dst := dst - 1

  dst <<= 4 << 2

  dst_1 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_2 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_3 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))
  dst_4 := (lookupz((dst <-= 4) & $F : "0".."9", "A".."F"))

  cksm := (-1*((290 + dst_1 + dst_2 + dst_3 + dst_4)//256))+256 

  Data.rxflush
  
  Data.tx(06)
  Data.tx(01)
  Data.tx(78)
  Data.tx(48)
  Data.tx(81)
  Data.tx(74)
  Data.tx(09)
  Data.hex(dst,4)
  Data.hex(cksm,2)
  Data.tx(04)

  Data.rxstr(@mystr)

  {
  debug.hex(mystr[1],1)
  debug.hex(mystr[2],1)
  debug.hex(mystr[3],1)
  debug.hex(mystr[4],1)
  debug.hex(mystr[5],1)
  debug.hex(mystr[6],1)
  debug.hex(mystr[7],1)
  debug.hex(mystr[8],1)
  debug.hex(mystr[9],1)
  debug.hex(mystr[10],1)
  debug.hex(mystr[11],1)
  debug.hex(mystr[12],1)
  debug.hex(mystr[13],1)
  debug.hex(mystr[14],1)
  debug.hex(mystr[15],1)
  debug.hex(mystr[16],1)
  }
  
  
  
  src := mystr
  


  Data.tx(06)
  